package io.renren.modules.sys.controller;

import java.util.Date;
import java.util.List;
import java.util.Map;

import javax.servlet.http.HttpServletResponse;
import javax.validation.constraints.Null;

import io.renren.common.utils.security.SM4Utils;
import org.apache.commons.lang3.StringUtils;
import org.apache.shiro.authz.annotation.RequiresPermissions;
import org.springframework.beans.factory.annotation.Autowired;
import org.springframework.beans.factory.annotation.Value;
import org.springframework.web.bind.annotation.DeleteMapping;
import org.springframework.web.bind.annotation.GetMapping;
import org.springframework.web.bind.annotation.PathVariable;
import org.springframework.web.bind.annotation.PostMapping;
import org.springframework.web.bind.annotation.PutMapping;
import org.springframework.web.bind.annotation.RequestBody;
import org.springframework.web.bind.annotation.RequestMapping;
import org.springframework.web.bind.annotation.RequestParam;
import org.springframework.web.bind.annotation.RestController;

import com.baomidou.mybatisplus.core.conditions.update.UpdateWrapper;

import io.renren.common.annotation.LogOperation;
import io.renren.common.constant.Constant;
import io.renren.common.page.PageData;
import io.renren.common.utils.ExcelUtils;
import io.renren.common.utils.Result;
import io.renren.common.validator.AssertUtils;
import io.renren.common.validator.ValidatorUtils;
import io.renren.common.validator.group.AddGroup;
import io.renren.common.validator.group.DefaultGroup;
import io.renren.common.validator.group.UpdateGroup;
import io.renren.modules.security.controller.AbstractController;
import io.renren.modules.sys.dto.CustomersDTO;
import io.renren.modules.sys.entity.CustomersEntity;
import io.renren.modules.sys.excel.CustomersExcel;
import io.renren.modules.sys.service.CustomersService;
import io.swagger.annotations.Api;
import io.swagger.annotations.ApiImplicitParam;
import io.swagger.annotations.ApiImplicitParams;
import io.swagger.annotations.ApiOperation;
import springfox.documentation.annotations.ApiIgnore;


/**
 * 客户表
 *
 * @author Mark sunlightcs@gmail.com
 * @since 1.0.0 2022-05-29
 */
@RestController
@RequestMapping("sys/customers")
@Api(tags="客户表")
public class CustomersController extends AbstractController{
    @Autowired
    private CustomersService customersService;
    /**
     * 加解密秘钥
     */
    @Value("${encrypt.token}")
    private String TRANSMIT_KEY;

    @GetMapping("page")
    @ApiOperation("分页")
    @ApiImplicitParams({
        @ApiImplicitParam(name = Constant.PAGE, value = "当前页码，从1开始", paramType = "query", required = true, dataType="int") ,
        @ApiImplicitParam(name = Constant.LIMIT, value = "每页显示记录数", paramType = "query",required = true, dataType="int") ,
        @ApiImplicitParam(name = Constant.ORDER_FIELD, value = "排序字段", paramType = "query", dataType="String") ,
        @ApiImplicitParam(name = Constant.ORDER, value = "排序方式，可选值(asc、desc)", paramType = "query", dataType="String")
    })
    @RequiresPermissions("sys:customers:page")
    public Result<PageData<CustomersDTO>> page(@ApiIgnore @RequestParam Map<String, Object> params){
        PageData<CustomersDTO> page = customersService.page(params);
        return new Result<PageData<CustomersDTO>>().ok(page);
    }

    @GetMapping("{id}")
    @ApiOperation("信息")
    @RequiresPermissions("sys:customers:info")
    public Result<CustomersDTO> get(@PathVariable("id") Long id){
        CustomersDTO data = customersService.get(id);
        String encryptMobile = SM4Utils.decryptData_ECB(data.getMobile(), TRANSMIT_KEY);
        data.setMobile(encryptMobile);
        return new Result<CustomersDTO>().ok(data);
    }

    @PostMapping
    @ApiOperation("保存")
    @LogOperation("保存")
    @RequiresPermissions("sys:customers:save")
    public Result save(@RequestBody CustomersDTO dto){
        //效验数据
        ValidatorUtils.validateEntity(dto, AddGroup.class, DefaultGroup.class);
        String encryptMobile = SM4Utils.encryptData_ECB(dto.getMobile(), TRANSMIT_KEY);
        dto.setMobile(encryptMobile);
        if (null == dto.getCompanyId()){
            dto.setCompanyId(0L);
        }
        customersService.save(dto);
        return new Result();
    }

    @PutMapping
    @ApiOperation("修改")
    @LogOperation("修改")
    @RequiresPermissions("sys:customers:update")
    public Result update(@RequestBody CustomersDTO dto){
        //效验数据
        ValidatorUtils.validateEntity(dto, UpdateGroup.class, DefaultGroup.class);
        String encryptMobile = SM4Utils.encryptData_ECB(dto.getMobile(), TRANSMIT_KEY);
        dto.setMobile(encryptMobile);
        if (null == dto.getCompanyId()){
            dto.setCompanyId(0L);
        }
        dto.setUpdateBy(getUserId());
        dto.setUpdateTime(new Date());
        customersService.update(dto);

        return new Result();
    }

    @DeleteMapping
    @ApiOperation("删除")
    @LogOperation("删除")
    @RequiresPermissions("sys:customers:delete")
    public Result delete(@RequestBody Long[] ids){
        //效验数据
        AssertUtils.isArrayEmpty(ids, "id");
        CustomersEntity entity = new CustomersEntity();
        //entity.setStatus(Constant.Status.DISABLE.getValue());//DeleteTime有值就是删除数据
        entity.setUpdateBy(getUserId());
        entity.setDeleteTime(new Date());
        customersService.update(entity, new UpdateWrapper<CustomersEntity>().in("id", ids));
        //customersService.delete(ids);
        return new Result();
    }

    @GetMapping("export")
    @ApiOperation("导出")
    @LogOperation("导出")
    @RequiresPermissions("sys:customers:export")
    public void export(@ApiIgnore @RequestParam Map<String, Object> params, HttpServletResponse response) throws Exception {
        List<CustomersDTO> list = customersService.list(params);

        ExcelUtils.exportExcelToTarget(response, null, list, CustomersExcel.class);
    }
    
    @GetMapping("againPush/{id}")
    @ApiOperation("重推")
    @LogOperation("重推")
    @RequiresPermissions("sys:customers:againPush")
    public Result<CustomersDTO> againPush(@PathVariable("id") Long id){
        CustomersEntity entity = new CustomersEntity();
        entity.setId(id);
        entity.setIsPush(Constant.PushStatus.UN_PUSH.getValue());
        entity.setStatus(Constant.Status.ENABLE.getValue());
        customersService.updateById(entity);
        return new Result();
    }

}